#!/bin/bash

ALERTS_JSONNET_PATH=../alerts
ALERTS_BUILD_PATH=../build/alerts
ALERTS_TAR_NAME=alerts
## /build/archive from the root of the project
ARCHIVE_PATH=../archive

CURRENT_DIR=$PWD

mkdir -p ${ALERTS_BUILD_PATH}
mkdir -p ${ARCHIVE_PATH}

echo "Cleaning up previous builds"
rm -rf ${ALERTS_BUILD_PATH}/*.json

for json_file in ${ALERTS_JSONNET_PATH}/*.jsonnet;
    do
      echo "Filename is $json_file"
      filename=$(basename -- "${json_file}")
      filename="${filename%.*}"
      JSONNET_PATH=../grafonnet-lib \
      jsonnet ${ALERTS_JSONNET_PATH}/${json_file} > ${ALERTS_BUILD_PATH}/${filename}.json
      echo "Created new json at ${ALERTS_BUILD_PATH}/${filename}.json"
    done

cd ${ALERTS_BUILD_PATH}

count_file=`ls -1 *.json 2>/dev/null | wc -l`
echo "${count_file} json files found at `pwd`"

if [ $count_file != 0 ]
 then
    tar -cvzf ${ARCHIVE_PATH}/${ALERTS_TAR_NAME}.tar.gz *.json
    echo "Uploading to $ARTIFACTORY_URL/grafonet/$CI_PIPELINE_ID/${ALERTS_TAR_NAME}.tar.gz"
    curl -u $ARTIFACTORY_USER:$ARTIFACTORY_PASS -T ${ARCHIVE_PATH}/${ALERTS_TAR_NAME}.tar.gz "$ARTIFACTORY_URL/grafonet/$CI_PIPELINE_ID/${ALERTS_TAR_NAME}.tar.gz"
    echo "Artifact Uploaded Successfully"
else
    echo  "ERROR: No json files found at ${ALERTS_BUILD_PATH}. Build process Failed"
    ls -larth ${ALERTS_BUILD_PATH}
    exit 1
fi

cd ${CURRENT_DIR}