#!/bin/bash

DASHBOARDS_JSONNET_PATH=../dashboards
DASHBOARDS_BUILD_PATH=../build/dashboards
DASHBOARDS_TAR_NAME=dashboards
## /build/archive from the root of the project
ARCHIVE_PATH=../archive

CURRENT_DIR=$PWD

mkdir -p ${DASHBOARDS_BUILD_PATH}
mkdir -p ${ARCHIVE_PATH}

echo "Cleaning up previous builds"
rm -rf ${DASHBOARDS_BUILD_PATH}/*.json

DASHBOARD_JSONNET_FILES=$(find ${DASHBOARDS_JSONNET_PATH} -type f -name "*.jsonnet" ! -path "../grafonnet-lib/*") #| xargs -I{} basename {}  )

LAST_COMMIT_FILES=$(git diff --name-only HEAD^ HEAD)
echo last commit files $LAST_COMMIT_FILES
echo dashboards files $DASHBOARD_JSONNET_FILES

UPDATED_DASHBOARDS=($(comm -12 <(echo "${LAST_COMMIT_FILES[@]}" | tr ' ' '\n' | sort) <(echo "${DASHBOARD_JSONNET_FILES[@]}" | tr ' ' '\n' | sort)))

exit

echo "creating jsons for ${#UPDATED_DASHBOARDS[@] } jsonnet files"

for json_file in ${UPDATED_DASHBOARDS[@]};
    do
      echo "Filename is $json_file"
      filename=$(basename -- "${json_file}")
      filename="${filename%.*}"
      JSONNET_PATH=../grafonnet-lib \
      jsonnet ${DASHBOARDS_JSONNET_PATH}/${json_file} > ${DASHBOARDS_BUILD_PATH}/${filename}.json
      echo "Created new json at ${DASHBOARDS_BUILD_PATH}/${filename}.json"
    done

#cd ${DASHBOARDS_BUILD_PATH}
#
#count_file=`ls -1 *.json 2>/dev/null | wc -l`
#echo "${count_file} json files found at `pwd`"
#
#if [ $count_file != 0 ]
# then
#    tar -cvzf ${ARCHIVE_PATH}/${DASHBOARDS_TAR_NAME}.tar.gz *.json
#    echo "Uploading to $ARTIFACTORY_URL/grafonet/$CI_PIPELINE_ID/${DASHBOARDS_TAR_NAME}.tar.gz"
#    curl -u $ARTIFACTORY_USER:$ARTIFACTORY_PASS -T ${ARCHIVE_PATH}/${DASHBOARDS_TAR_NAME}.tar.gz "$ARTIFACTORY_URL/grafonet/$CI_PIPELINE_ID/${DASHBOARDS_TAR_NAME}.tar.gz"
#    echo "Artifact Uploaded Successfully"
#else
#    echo  "ERROR: No json files found at ${DASHBOARDS_BUILD_PATH}. Build process Failed"
#    ls -larth ${DASHBOARDS_BUILD_PATH}
#    exit 1
#fi

cd ${CURRENT_DIR}